<?php

namespace EventPortal\Domain\EventDelegate\Handlers;

use Closure;
use EventPortal\Domain\Delegate\Models\DelegateFormStep;
use EventPortal\Domain\Event\Form\Enums\State;
use EventPortal\Domain\Form\Payload;

class UpdateProgress
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $delegate = $payload->getContext('eventDelegate')->delegate;
        $formStep = $payload->getContext('formStep');

        DelegateFormStep::updateOrCreate(
            [
                'delegate_id' => $delegate->id,
                'form_step_id' => $formStep->id,
            ],
            [
                'state' => State::Complete()->getValue(),
                'delegate_id' => $delegate->id,
                'form_step_id' => $formStep->id,
            ]
        );

        return $next($payload);
    }
}
